"use strict";
var Entry = require('./Entry');
var normalizeUrl = require('./normalizeUrl');
var Mapper = function() {
  function Mapper() {
    this.entries = [];
  }
  return ($traceurRuntime.createClass)(Mapper, {
    add: function(urlTemplate, objectTemplate, options) {
      return this.addEntry(new Entry(urlTemplate, objectTemplate, options));
    },
    addEntry: function(entry) {
      if (typeof entry.fromURL !== 'function' || typeof entry.toURL !== 'function') {
        throw Error('An entry must implement fromURL(url) -> object and toURL(object) -> url');
      }
      this.entries.push(entry);
      return this;
    },
    fromURL: function(url, options) {
      var normalize = !options || options.normalize !== false;
      if (normalize) {
        url = normalizeUrl(url);
      }
      var $__5 = true;
      var $__6 = false;
      var $__7 = undefined;
      try {
        for (var $__3 = void 0,
            $__2 = (this.entries)[$traceurRuntime.toProperty(Symbol.iterator)](); !($__5 = ($__3 = $__2.next()).done); $__5 = true) {
          var entry = $__3.value;
          {
            var result = entry.fromURL(url, {normalize: false});
            if (result !== null) {
              return result;
            }
          }
        }
      } catch ($__8) {
        $__6 = true;
        $__7 = $__8;
      } finally {
        try {
          if (!$__5 && $__2.return != null) {
            $__2.return();
          }
        } finally {
          if ($__6) {
            throw $__7;
          }
        }
      }
      return null;
    },
    toURL: function(object) {
      var $__5 = true;
      var $__6 = false;
      var $__7 = undefined;
      try {
        for (var $__3 = void 0,
            $__2 = (this.entries)[$traceurRuntime.toProperty(Symbol.iterator)](); !($__5 = ($__3 = $__2.next()).done); $__5 = true) {
          var entry = $__3.value;
          {
            var result = entry.toURL(object);
            if (result !== null) {
              return result;
            }
          }
        }
      } catch ($__8) {
        $__6 = true;
        $__7 = $__8;
      } finally {
        try {
          if (!$__5 && $__2.return != null) {
            $__2.return();
          }
        } finally {
          if ($__6) {
            throw $__7;
          }
        }
      }
      return null;
    }
  }, {});
}();
module.exports = Mapper;
Mapper.Entry = Entry;
