"use strict";
function returnNegativeOne() {
  return -1;
}
function returnTrue() {
  return true;
}
function returnUndefined() {
  return undefined;
}
function compareObject(template, object, options) {
  var verifyValue = options && options.verifyValue || returnUndefined;
  var placeholderValues = options && options.values;
  var indexOfPlaceholder = options && options.indexOfPlaceholder || returnNegativeOne;
  var verifyPlaceholder = options && options.verifyPlaceholder || returnTrue;
  var customVerify = verifyValue(template, object);
  if (typeof customVerify === 'boolean') {
    return customVerify;
  }
  var placeHolderIndex = indexOfPlaceholder(template);
  if (placeHolderIndex >= 0) {
    var placeholder = template;
    if (!verifyPlaceholder(placeholder, object)) {
      return false;
    }
    if (placeholderValues) {
      placeholderValues[placeHolderIndex] = object;
    }
    return true;
  }
  if (typeof template !== 'object' || typeof object !== 'object' || template === null || object === null) {
    return template === object;
  }
  if (Array.isArray(template)) {
    if (!Array.isArray(object) || template.length !== object.length) {
      return false;
    }
    for (var i = 0; i < template.length; ++i) {
      if (!compareObject(template[i], object[i], options)) {
        return false;
      }
    }
  }
  var templateKeys = Object.keys(template);
  var objectKeys = Object.keys(object);
  if (templateKeys.length !== objectKeys.length) {
    return false;
  }
  templateKeys.sort();
  objectKeys.sort();
  for (var i$__0 = 0; i$__0 < templateKeys.length; ++i$__0) {
    if (templateKeys[i$__0] !== objectKeys[i$__0]) {
      return false;
    }
  }
  for (var i$__1 = 0; i$__1 < templateKeys.length; ++i$__1) {
    var key = templateKeys[i$__1];
    if (!compareObject(template[key], object[key], options)) {
      return false;
    }
  }
  return true;
}
module.exports = compareObject;
